unit ADSUtils;

interface

//////////////////////////////////////////////////////////////////////////
//
// alternate data streamAPIȂ
//
// Copyright (C) 2009 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @A]ځEzzƂ̓A[JCu̍\͕ςȂłB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́A؂̐ӔCE`
//   𕉂܂BgpɂȂ̐ӔČɁǍʂ𕉂Ă
//   Bꂪ[Ȃ̂ł΁ApfOĂB
//
// rev  0
// date 2009/03/07-2009/03/08
// auth fT
// memo o
//      Qurl http://www.nslabs.jp/ntfs_alt_stream.rhtml
//
// rev  1
// date 2009/07/08
// auth fT
// memo APIgpo[Wŕϐ̏Yꂪ~XC
//      APIgpo[WADSfBNgɑ΂
//      FindFirstStreamgGetLastErrorERROR_INVALID_HANDLE
//      Ԃ̂CAERROR_HANDLE_EOFԂ悤ɕύX
//
// FindFirstStreamW/FindNextStreamWVISTA/2003ȍ~łgȂB
// FindFirstStreamW > FindNextStreamW > FindClose̗ŎgpB
//
// VISTA/2003ȑOCreateFile/BackupReadœǂݍ or undocumented
// NtQueryInformationFilegpB
// CreateFile/BackupReadg@ŎB
//
/////////////////////////////////////////////////////////////////////////

uses
  windows,sysutils;

// for VISTA/2003ȍ~
const
  FindStreamInfoStandard=0;  // STREAM_INFO_LEVELS

type
  STREAM_INFO_LEVELS = integer;

  _WIN32_FIND_STREAM_DATA = packed record
    StreamSize  : int64;
    cStreamName : array[0..MAX_PATH + 36-1] of WideChar;
  end;
  TWIN32_FIND_STREAM_DATA = _WIN32_FIND_STREAM_DATA;
  PWIN32_FIND_STREAM_DATA = ^TWIN32_FIND_STREAM_DATA;

function FindFirstStreamW( lpFilename:PWideChar; InfoLevel:STREAM_INFO_LEVELS;
                           lpFindStreamData:pointer; dwFlags:DWORD):THANDLE; stdcall;
function FindNextStreamW( hFindStream:THANDLE; lpFindStreamData:pointer):BOOL; stdcall;

// SĂNTFSŎgver.
const
  BACKUP_DATA           = 1; // Standard data
  BACKUP_EA_DATA        = 2; // Extended attribute data
  BACKUP_SECURITY_DATA  = 3; // Security descriptor data
  BACKUP_ALTERNATE_DATA = 4; // Alternate data stream
  BACKUP_LINK           = 5; // Hard link information
  BACKUP_PROPERTY_DATA  = 6; // Property data
  BACKUP_OBJECT_ID      = 7; // Objects identifiers
  BACKUP_REPARSE_DATA   = 8; // Reparse points
  BACKUP_SPARSE_BLOCK   = 9; // Sparse file

type
  TAltWIN32StreamID = packed record
    dwStreamId: DWORD;
    dwStreamAttributes: DWORD;
    Size: TLargeInteger;
    dwStreamNameSize: DWORD;
  end;

  TFindStreamData = record
  private
    FStreamSize : int64;
    FStreamName : string;
    // pf[^
    FHandle : THANDLE;
    FHeader : TAltWIN32StreamID;
    pName : PWideChar;
    pNameSize : DWORD;
    pContent : pointer;
    // VISTA/2003ȍ~
    FData : TWIN32_FIND_STREAM_DATA;
    UseAPI :boolean;
  public
    property StreamSize : int64 read FStreamSize;
    property StreamName : string read FStreamName;
  end;
  PFindStreamData = ^TFindStreamData;

function FindFirstStream( AFilename:string; var AData:TFindStreamData ):boolean;
function FindNextStream( var AData:TFindStreamData ):boolean;
function FindCloseStream( var AData:TFindStreamData ):boolean;

var
  _ForceOldStyleFindXXXStream : boolean;

implementation

procedure MakeNameBuff(var pName:PWideChar; var OldNameSize:DWORD; NewNameSize:DWORD);
begin
  if OldNameSize>=NewNameSize then begin
    FillChar(pName^,OldNameSize+Sizeof(WideChar),0);
    Exit;
  end;
  if pName<>nil then begin
    freemem(pName);
    pName:=nil;
  end;
  pName:=AllocMem(NewNameSize+sizeof(WideChar)); // with 0 clear, +sizeof(WideChar)\0̂߂
  OldNameSize:=NewNameSize;
end;

function ReadHeader(var AData:TFindStreamData):boolean;
const
  DefaultName = '::$DATA';
type
  TDmy = packed record
    dl,dh : DWORD;
  end;
  PDmy = ^TDmy;
var
  dmy    : PDmy;
  dl,dh  : DWORD;
  rdsize : Cardinal;
  done   : boolean;
begin
  result:=false;
  WITH AData DO BEGIN
    REPEAT
      // ̃wb_ʒuɈړ
      if FHeader.size>0 then begin
        dmy:=PDmy(@FHeader.size);
        if NOT BackupSeek(FHandle,dmy^.dl,dmy^.dh,dl,dh,pContent) then exit;
      end;
      // wb_ǂݍ
      if NOT BackupRead(FHandle,@FHeader,sizeof(FHeader),rdsize,false,false,pContent) then Exit;
      if rdsize<>sizeof(FHeader) then begin
        if rdsize=0 then SetLastError(ERROR_HANDLE_EOF); // IɓBƂɂ
        exit; // I
      end;
      MakeNameBuff(pName,pNameSize,FHeader.dwStreamNameSize); // ADS̖O̒m
      // Oǂݍ
      if FHeader.dwStreamNameSize>0 then begin
        if NOT BackupRead(FHandle,PByte(pName),FHeader.dwStreamNameSize,rdsize,false,false,pContent) then Exit;
        if rdsize<>FHeader.dwStreamNameSize then exit; // f[^|ǂݍ߂ĂȂH
      end;
      // f[^̔ - main dataalternate dataȂokBȂȂ玟̃f[^
      done:=FHeader.dwStreamID in [BACKUP_DATA,BACKUP_ALTERNATE_DATA];
    UNTIL done;
    // f[^Zbg
    FStreamSize:=FHeader.Size;
    if FHeader.dwStreamId=BACKUP_DATA then
      // FindFirst/Nextɍ킹邽߂ɕύX
      FStreamName:=DefaultName
    else
      FStreamName:=pName;
    result:=true;
  END;
end;

function FindFirstStream( AFilename:string; var AData:TFindStreamData ):boolean;
begin
  result:=false;
  WITH AData DO BEGIN
    UseAPI:=(Win32MajorVersion>=6) OR // VISTA or Later
            ((Win32MajorVersion=5) AND (Win32MinorVersion>=2)); // 2003 or Later
    if _ForceOldStyleFindXXXStream then UseAPI:=false;
    pName:=nil; pNameSize:=0;
    pContent:=nil;
    if UseAPI then begin
      FHandle:=FindFirstStreamW(PWideChar(AFilename),FindStreamInfoStandard,@FData,0);
      if FHandle=INVALID_HANDLE_VALUE then exit; // G[Ȃ̂ŏI
      FStreamName:=FData.cStreamName;
      FStreamSize:=FData.StreamSize;
      result:=true;
    end else begin
      // ŏADSNamë̗KɊm
      MakeNameBuff(pName,pNameSize,MAX_PATH + 36);
      // Ώۂopen
      FHandle:=CreateFile( PWideChar(AFilename),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,0);
      if FHandle=INVALID_HANDLE_VALUE then exit; // G[Ȃ̂ŏI
      // headerǂݍ
      AData.FHeader.Size:=0; // clearĂƁI
      result:=ReadHeader(AData);
    end;
  END;
end;

function FindNextStream( var AData:TFindStreamData ):boolean;
begin
  result:=false;
  WITH AData DO BEGIN
    if FHandle=INVALID_HANDLE_VALUE then Exit;
    if UseAPI then begin
      result:=FindNextStreamW(FHandle,@FData);
      if result then begin
        FStreamName:=FData.cStreamName;
        FStreamSize:=FData.StreamSize;
      end;
    end else begin
      // headerǂݍ
      result:=ReadHeader(AData);
    end;
  END;
end;

function FindCloseStream( var AData:TFindStreamData ):boolean;
var
  rs : DWORD;
begin
  result:=true;
  WITH AData DO BEGIN
    if pName<>nil then begin
      FreeMem(pName);
      pName:=nil; pNameSize:=0;
    end;
    if FHandle<>INVALID_HANDLE_VALUE then begin
      if UseAPI then
        result:=windows.FindClose(FHandle)
      else begin
        result:=BackupRead(FHandle,nil,0,rs,true,false,pContent);
        CloseHandle(FHandle);
      end;
      FHandle:=INVALID_HANDLE_VALUE;
    end;
  END;
end;

function _dmy_FindFirstStreamW( lpFilename:PWideChar; InfoLevel:STREAM_INFO_LEVELS;
                           lpFindStreamData:pointer; dwFlags:DWORD):THANDLE; stdcall;
begin
  result:=INVALID_HANDLE_VALUE;
  SetLastError( ERROR_CALL_NOT_IMPLEMENTED );
end;

function _dmy_FindNextStreamW( hFindStream:THANDLE; lpFindStreamData:pointer):BOOL; stdcall;
begin
  result:=FALSE;
  SetLastError( ERROR_CALL_NOT_IMPLEMENTED );
end;

var
  _FindFirstStreamW:function( lpFilename:PWideChar; InfoLevel:STREAM_INFO_LEVELS;
                              lpFindStreamData:pointer; dwFlags:DWORD):THANDLE; stdcall;
  _FindNextStreamW:function( hFindStream:THANDLE; lpFindStreamData:pointer):BOOL; stdcall;
  hkernel32 : THANDLE;


function FindFirstStreamW( lpFilename:PWideChar; InfoLevel:STREAM_INFO_LEVELS;
                           lpFindStreamData:pointer; dwFlags:DWORD):THANDLE; stdcall;
begin
  result:=_FindFirstStreamW(lpFIlename,InfoLevel,lpFindStreamData,dwFlags);
end;

function FindNextStreamW( hFindStream:THANDLE; lpFindStreamData:pointer):BOOL; stdcall;
begin
  result:=_FindNextStreamW(hFindStream,lpFindStreamData);
end;

procedure Init;
var
  sv : integer;
  p  : TFarProc;
begin
  _ForceOldStyleFindXXXStream:=false;
  _FindFirstStreamW:=_dmy_FindFirstStreamW;
  _FindNextStreamW:=_dmy_FindNextStreamW;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    HKernel32:=LoadLibrary('kernel32.dll');
    IF HKernel32<>0 THEN BEGIN
      p:=GetProcAddress(HKernel32,'FindFirstStreamW');
      IF p<>nil THEN BEGIN
        @_FindFirstStreamW:=p;
      END;
      p:=GetProcAddress(HKernel32,'FindNextStreamW');
      IF p<>nil THEN BEGIN
        @_FindNextStreamW:=p;
      END;
    END;
  finally
    SetErrorMode(sv);
  end;
end;

procedure done;
begin
  if hkernel32<>0 then begin
    _FindFirstStreamW:=_dmy_FindFirstStreamW;
    _FindNextStreamW:=_dmy_FindNextStreamW;
    FreeLibrary(hkernel32);
    hkernel32:=0;
  end;
end;

initialization
  Init;

finalization
  done;

end.
