unit WideCharUtils;

/////////////////////////////////////////////////////////////////////////////
//
// WideChar֘A̎葱
//
// Copyright (C) 2004-2008 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @łA]ځEzzƂ̓A[JCu̍\͕ςȂłˁB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂiĂ邩
//   ǂ͉ǂl̈ӎvłjBÃjbgɂĂ
//   E`͈ɂ́uvƂ͖LĂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́AؐӔC𕉂
//   B
//
// rev  0
// date ?
// auth fT
// memo 
//
// rev  1
// date 2008/10/18-2008/11/16
// auth fT
// memo Delphi2009ɈڐA
//
/////////////////////////////////////////////////////////////////////////////

interface

const
  NetRootU  = '\\';
  YenU      = WideChar('\');
  SpcU      = WideChar(' ');
  DQuatU    = WideChar('"');
  SQuatU    = WideChar('''');
  SlashU    = WideChar('/');
  ColonU    = WideChar(':');
  AsteriskU = WideChar('*');
  QuestionU = WideChar('?');
  LessU     = WideChar('<');
  GreaterU  = WideChar('>');
  PipeU     = WideChar('|');

type
  // cwtUnicode .... Unicode Rule
  // cwtAnsi ....... ANSI Rule(łA-Z,a-ẑ)
  TCaseWType = (cwtUnicode,cwtAnsi);

// UpCaseWideCharo[W
function AyaUpCase(ch:WideChar; mode:TCaseWType=cwtAnsi):WideChar;
// DownCaseWideCharo[W
function AyaDownCase(ch:WideChar; mode:TCaseWType=cwtAnsi):WideChar;
// AnsiLastCharWideo[W -> WideStrUtilsɂł
//function WideLastChar(trg:WideString):PWideChar;

// ϊΏۂ𐧌łWide(Upper/Lower)Case
function AyaUpperCase(const src:String; md:TCaseWType=cwtAnsi):String;
function AyaLowerCase(const src:String; md:TCaseWType=cwtAnsi):String;

// r[𐧌łWideComapreText
function AyaCompareText(const src,dst:String; md:TCaseWtype=cwtAnsi):integer;

// ASrcŎw肳ꂽt@CANSIɕϊƂɁAϊłȂ
// u΁v^Ԃ
function CheckSafeConvW2A(ASrc:String):boolean;


implementation

uses
  SysUtils,windows;

function AyaUpCase(ch:WideChar; mode:TCaseWType):WideChar;
begin
  result:=ch;
  CASE mode OF
    cwtUnicode:
      result:=UpCase(ch);
    cwtAnsi:
      IF (ord('A')<=ord(ch)) and (ord(ch)<=ord('Z')) THEN
        result:=UpCase(ch);
  END;
end;

function AyaDownCase(ch:WideChar; mode:TCaseWType):WideChar;
begin
  result:=ch;
  CASE mode OF
    cwtUnicode:
      result:=LowerCase(ch)[1];
    cwtAnsi:
      IF (ord('a')<=ord(ch)) and (ord(ch)<=ord('z')) THEN
        result:=LowerCase(ch)[1];
  END;
end;

// ϊΏۂ𐧌łWide(Upper/Lower)Case
function AyaUpperCase(const src:String; md:TCaseWType):String;
var
  i : integer;
begin
  IF md=cwtUnicode THEN
    result:=UpperCase(src)
  ELSE BEGIN
    result:=src;
    FOR i:=1 TO Length(result) DO result[i]:=AyaUpCase(result[i],md);
  END;
end;

function AyaLowerCase(const src:String; md:TCaseWType):String;
var
  i : integer;
begin
  IF md=cwtUnicode THEN
    result:=LowerCase(src)
  ELSE BEGIN
    result:=src;
    FOR i:=1 TO Length(result) DO result[i]:=AyaDownCase(result[i],md);
  END;
end;

// r[𐧌łWideComapreText
function AyaCompareText(const src,dst:String; md:TCaseWtype):integer;
begin
  IF md=cwtUnicode THEN
    result:=CompareText(src,dst)
  ELSE
    result:=CompareStr(AyaUpperCase(src,md),AyaUpperCase(dst,md));
end;

function CheckSafeConvW2A(ASrc:String):boolean;
var
  b : BOOL;
begin
  IF 0=WideCharToMultiByte(CP_ACP,0,PWideChar(ASrc),Length(ASrc),nil,0,nil,@b) THEN
    result:=false
  ELSE
    result:=NOT b;
end;


end.
 