unit adsf;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TADSForm = class(TForm)
    TrgLB: TLabel;
    ADSLBox: TListBox;
    UseAPICBox: TCheckBox;
    MakeBtn: TButton;
    StsBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure ADSLBoxDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MakeBtnClick(Sender: TObject);
  private
    { Private 錾 }
    lst : TStringList;
    szary : array of int64;
    procedure WmDropFiles(var AMsg:TWMDropFiles); message WM_DROPFILES;
  public
    { Public 錾 }
  end;

var
  ADSForm: TADSForm;

implementation

{$R *.dfm}

uses
  savef,saveprogf,shellapi,ayafutilu,ADSUtils;

procedure TADSForm.FormCreate(Sender: TObject);
begin
  UseAPICBox.Enabled:=(Win32MajorVersion>=6) OR // VISTA or Later
                      ((Win32MajorVersion=5) AND (Win32MinorVersion>=2));
  UseAPICBox.Checked:=UseAPICBox.Enabled;
  DragAcceptFiles(handle,true);
  lst:=TStringList.Create;
end;

procedure TADSForm.FormDestroy(Sender: TObject);
begin
  lst.free;
end;

procedure TADSForm.WmDropFiles(var AMsg:TWMDropFiles);
var
  fl:TStringList;
  fsd:TFindStreamData;
  i : integer;
begin
  fl:=GetDropFilesU(AMsg);
  if fl<>nil then begin
    try
      TrgLB.Caption:=fl[0];
      ADSLBox.Clear;
      lst.Clear;
      i:=0;
      _ForceOldStyleFindXXXStream:=NOT UseAPICBox.Checked;
      if FindFirstStream(fl[0],fsd) then begin
        repeat
          if fsd.StreamName='' then
            ADSLBox.Items.Add('name=n/a, size='+IntToStr(fsd.streamSize)) // 蓾Ȃ͂B
          else
            ADSLBox.Items.Add('name=<'+fsd.StreamName+'>, size='+IntToStr(fsd.streamSize));
          lst.add(fsd.streamName);
          SetLength(szary,i+1);
          szary[i]:=fsd.streamsize; Inc(i);
        until not FindNextStream(fsd);
        StsBar.SimpleText:='ok!';
      end else begin
        i:=GetLastError;
        if i=ERROR_HANDLE_EOF then
          StsBar.SimpleText:='ok!'
        else
          StsBar.SimpleText:='err('+IntToStr(i)+'):'+SysErrorMessage(i);
      end;
    finally
      FindCloseStream(fsd);
      fl.free;
    end;
  end;
end;

procedure TADSForm.ADSLBoxDblClick(Sender: TObject);
var
  svname :string;
begin
  IF (ADSLBox.Items.Count<1) or
     (ADSLBox.ItemIndex<0) or
     (lst[ADSLBox.ItemIndex]='') or
     (lst[ADSLBox.ItemIndex]='::$DATA') THEN Exit;
  IF SaveDlg(self,ExtractFilename(TrgLB.caption)+lst[ADSLBox.ItemIndex],svname) THEN
    DoSave(self,TrgLB.caption+lst[ADSLBox.ItemIndex],szary[ADSLBox.ItemIndex],svname);
end;

procedure TADSForm.MakeBtnClick(Sender: TObject);
const
  dmyname = 'adstest.txt';
  dmyfname = 'adstest';
  datsize = 1000;
var
  d : TFileStream;
  i : integer;
  buf : array[0..datsize-1] of byte;
  s : string;
begin
  // write main data
  d:=TFileStream.Create(dmyname,fmCreate);
  s:=#$FEFF+'ABCDEFG';
  d.write(s[1],Length(s)*sizeof(WideChar));
  d.free;
  // write alternate data
  d:=TFileStream.Create(dmyname+':ZZZ',fmCreate);
  s:=#$FEFF+'ZZZZZZZZZZZZZZZZZ';
  d.write(s[1],Length(s)*sizeof(WideChar));
  d.free;
  // write alternate data
  d:=TFileStream.Create(dmyname+':binary',fmCreate);
  for I := 1 to 1000 do begin
    FillChar(buf[0],datsize,i);
    d.write(buf[0],datsize);
  end;
  d.free;
  // write alternate data
  d:=TFileStream.Create(dmyname+':m',fmCreate);
  s:=#$FEFF+'Òr^򍞂ސ̉';
  d.write(s[1],Length(s)*sizeof(WideChar));
  d.free;
  // make folder
  ForceDirectories(dmyfname);
  // write alternate data
  d:=TFileStream.Create(dmyfname+':ADS on Folder',fmCreate);
  s:=#$FEFF+'ADS on Folder Data';
  d.write(s[1],Length(s)*sizeof(WideChar));
  d.free;
end;

end.
