unit ayanetobjs;

//////////////////////////////////////////////////////////////////////////
//
// lbg[N֘ÃIuWFNg
//
// rev. 1
// date 2009/05/26
// auth 
// memo ayafutiltꕔlbg[N֘AIuWFNg𕪗
//
// rev. 2
// date 2009/06/03-2009/06/05
// auth 
// memo Containerobjectscountchildren߂ĎQƂ鎞AI
//      Ɏqobjects𐶐悤ɕύX
//      Dupulicate֐ǉBContainerObject́ADuplicate_
//      Ăq𕡐Bxq̎QƂĂȂ
//      qObject͐ĂȂBKvȂDuplicate܂update
//      s邱
//
//////////////////////////////////////////////////////////////////////////

interface

uses
  windows,sysutils,classes;

type
  // for NetResource
  TNRScope = (nrsUNKNOWN,nrsCONNECTED,nrsGLOBALNET,nrsREMEMBERED,
              nrsRECENT,nrsCONTEXT);
  TNRResType = (nrrUNKNOWN,nrrANY,nrrDISK,nrrPRINT,nrrRESERVED);
  TNRResTypes = set of TNRResType;
  TNRDispType = (nrdUNKNOWN,nrdGENERIC,nrdDOMAIN,nrdSERVER,nrdSHARE,nrdFILE,
                 nrdGROUP,nrdNETWORK,nrdROOT,nrdSHAREADMIN,nrdDIRECTORY,
                 nrdTREE,nrdNDSCONTAINER);

  // for NeedPasswd
  TPasswdType = (npwNONE,npwSERVER,npwSHARE);

  // lbg[N֘A̒`
  PNetResourceWArray = ^TNetResourceWArray;
  TNetResourceWArray = array[0..(MaxInt div SizeOf(TNetResourceW) - 1)] of TNetResourceW;

  TNetResourceObjU = class(TObject)
  private
    FRes : TNetResourceW;
    FLocalName,
    FRemoteName,
    FComment,
    FProvider : String;
  protected
    function    GetScope:TNRScope;
    function    GetResType:TNRResTypes;
    function    GetDispType:TNRDispType;
    function    GetConnectable:boolean;
    function    GetContainer:boolean;
    function    GetNoLocalDevice:boolean;
    function    GetSibling:boolean;
    function    GetAttached:boolean;
  public
    constructor Create(src:TNetResourceW);  reintroduce; virtual;
    destructor  Destroy; override;
    //
    function    Duplicate:TNetResourceObjU; virtual;
    //
    property    NetRes : TNetResourceW read FRes;
    //
    property    Scope : TNRScope read GetScope;
    property    ResTypes : TNRResTypes read GetResType;
    property    DispType : TNRDispType read GetDispType;
    property    Connectable : boolean read GetConnectable;
    property    Container : boolean read GetContainer;
    property    NoLocalDevice : boolean read GetNoLocalDevice;
    property    Sibling : boolean read GetSibling;
    property    Attached : boolean read GetAttached;
    property    LocalName : String read FLocalName;
    property    RemoteName : String read FRemoteName;
    property    Comment : String read FComment;
    property    Provider : String read FProvider;
  end;

  TNetResourceObjListU = class(TStringList)
  protected
    function    GetNRObjU(index:integer):TNetResourceObjU;
  public
    constructor Create; reintroduce;
    destructor  Destroy; override;
    //
    property    NRObjU[index:integer] : TNetResourceObjU read GetNRObjU;
  end;

  TNetResourceContainerObjU = class(TNetResourceObjU)
  private
    FList: TNetResourceObjListU;
    FInitDone : boolean;
  protected
    function    GetCount:integer; virtual;
    function    GetChildren(index:integer):TNetResourceObjU; virtual;
    procedure   UpdateChildren; virtual;
    //
    property    InitDone : boolean read FInitDone;
  public
    constructor Create(src:TNetResourceW); override;
    destructor  Destroy; override;
    procedure   Update;
    function    Duplicate:TNetResourceObjU; override;
    //
    property    Count:integer read GetCount;
    property    Children[index:integer]:TNetResourceObjU read GetChildren;
  end;

  TServerObjU   = class(TNetResourceContainerObjU)
  protected
    function    PlasticShareName(AName:string):string;
  public
    function    FindShareIndex(AName:string):integer;
    function    FindShare(AName:string):TNetResourceObjU;
  end;

  TDomainObjU   = class(TNetResourceContainerObjU)
  protected
    function    GetServer(index:integer):TServerObjU;
    function    PlasticSrvName(AName:string):string;
  public
    function    FindSrvIndex(AName:string):integer;
    function    FindServer(AName:string):TServerObjU;
    property    Server[index:integer]:TServerObjU read GetServer;
  end;

function GetNetworkListU(pRootRes:PNetResourceW; Scope,ResType,Usage:DWORD; list:TStrings; recursive,needobj:boolean):integer;

implementation

///////////////////////////////////////////////////////////////////////////
//
// TNetResourceObjU Factory
//
///////////////////////////////////////////////////////////////////////////
function NetResObjFactory(ARes:TNetResourceW):TNetResourceObjU;
begin
  if ARes.dwDisplayType=RESOURCEDISPLAYTYPE_DOMAIN then
    result:=TDomainObjU.Create(ARes)
  else if ARes.dwDisplayType=RESOURCEDISPLAYTYPE_SERVER then
    result:=TServerObjU.Create(ARes)
  else if 0<>(ARes.dwUsage AND RESOURCEUSAGE_CONTAINER) then
    result:=TNetResourceContainerObjU.Create(ARes)
  else
    result:=TNetResourceObjU.Create(ARes);
end;

///////////////////////////////////////////////////////////////////////////
//
// TNetResourceObjListU
//
///////////////////////////////////////////////////////////////////////////

constructor TNetResourceObjListU.Create;
begin
  inherited Create;
  Sorted:=true;
  CaseSensitive:=false;
  Duplicates:=dupError; // OI
  OwnsObjects:=true;
end;

destructor  TNetResourceObjListU.Destroy;
begin
  Clear;
  inherited Destroy;
end;

function    TNetResourceObjListU.GetNRObjU(index:integer):TNetResourceObjU;
begin
  result:=TNetResourceObju(Objects[index]);
end;

///////////////////////////////////////////////////////////////////////////
//
// TNetResourceObjU
//
///////////////////////////////////////////////////////////////////////////

constructor TNetResourceObjU.Create(src:TNetResourceW);
begin
  inherited Create;
  FRes:=src;
  IF (Scope=nrsREMEMBERED) AND (nil<>FRes.lpLocalName) THEN BEGIN
    FLocalName:=FRes.lpLocalName;
    FRes.lpLocalName:=@FLocalName[1];
  END ELSE
    FLocalName:='';
  IF nil=FRes.lpRemoteName THEN
    FRemoteName:=''
  ELSE BEGIN
    FRemoteName:=FRes.lpRemoteName;
    FRes.lpRemoteName:=@FRemoteName[1];
  END;
  IF nil=FRes.lpComment THEN
    FComment:=''
  ELSE BEGIN
    FComment:=FRes.lpComment;
    FRes.lpComment:=@FComment[1];
  END;
  IF nil=FRes.lpProvider THEN
    FProvider:=''
  ELSE BEGIN
    FProvider:=FRes.lpProvider;
    FRes.lpProvider:=@FProvider[1];
  END;
end;

destructor  TNetResourceObjU.Destroy;
begin
  FLocalName:=''; FRemoteName:=''; FComment:=''; FProvider:='';
  inherited;
end;

function    TNetResourceObjU.GetScope:TNRScope;
begin
  result:=nrsUNKNOWN;
  CASE FRes.dwScope OF
    RESOURCE_CONNECTED:  result:=nrsCONNECTED;
    RESOURCE_GLOBALNET:  result:=nrsGLOBALNET;
    RESOURCE_REMEMBERED: result:=nrsREMEMBERED;
    RESOURCE_RECENT:     result:=nrsRECENT;
    RESOURCE_CONTEXT:    result:=nrsCONTEXT;
  END;
end;

function    TNetResourceObjU.GetResType:TNRResTypes;
begin
  IF FRes.dwType=RESOURCETYPE_UNKNOWN THEN
    result:=[nrrUNKNOWN]
  ELSE BEGIN
    result:=[];
    IF 0<>(FRes.dwType AND RESOURCETYPE_DISK) THEN
      Include(result,nrrDISK);
    IF 0<>(FRes.dwType AND RESOURCETYPE_PRINT) THEN
      Include(result,nrrPRINT);
    IF 0<>(FRes.dwType AND RESOURCETYPE_RESERVED) THEN
      Include(result,nrrRESERVED);
    IF result=[] THEN result:=[nrrANY];
  END;
end;

function    TNetResourceObjU.GetDispType:TNRDispType;
begin
  result:=nrdUNKNOWN;
  CASE FRes.dwDisplayType OF
    RESOURCEDISPLAYTYPE_GENERIC      : result:=nrdGENERIC;
    RESOURCEDISPLAYTYPE_DOMAIN       : result:=nrdDOMAIN;
    RESOURCEDISPLAYTYPE_SERVER       : result:=nrdSERVER;
    RESOURCEDISPLAYTYPE_SHARE        : result:=nrdSHARE;
    RESOURCEDISPLAYTYPE_FILE         : result:=nrdFILE;
    RESOURCEDISPLAYTYPE_GROUP        : result:=nrdGROUP;
    RESOURCEDISPLAYTYPE_NETWORK      : result:=nrdNETWORK;
    RESOURCEDISPLAYTYPE_ROOT         : result:=nrdROOT;
    RESOURCEDISPLAYTYPE_SHAREADMIN   : result:=nrdSHAREADMIN;
    RESOURCEDISPLAYTYPE_DIRECTORY    : result:=nrdDIRECTORY;
    RESOURCEDISPLAYTYPE_TREE         : result:=nrdTREE;
    RESOURCEDISPLAYTYPE_NDSCONTAINER : result:=nrdNDSCONTAINER;
  END;
end;

function    TNetResourceObjU.GetConnectable:boolean;
begin
  result:=(Scope=nrsGLOBALNET) AND
          (0<>(FRes.dwUsage AND RESOURCEUSAGE_CONNECTABLE));
end;

function    TNetResourceObjU.GetContainer:boolean;
begin
  result:=(Scope=nrsGLOBALNET) AND
          (0<>(FRes.dwUsage AND RESOURCEUSAGE_CONTAINER));
end;

function    TNetResourceObjU.GetNoLocalDevice:boolean;
begin
  result:=(Scope=nrsGLOBALNET) AND
          (0<>(FRes.dwUsage AND RESOURCEUSAGE_NOLOCALDEVICE));
end;

function    TNetResourceObjU.GetSibling:boolean;
begin
  result:=(Scope=nrsGLOBALNET) AND
          (0<>(FRes.dwUsage AND RESOURCEUSAGE_SIBLING));
end;

function    TNetResourceObjU.GetAttached:boolean;
begin
  result:=(Scope=nrsGLOBALNET) AND
          (0<>(FRes.dwUsage AND RESOURCEUSAGE_ATTACHED));
end;

function    TNetResourceObjU.Duplicate:TNetResourceObjU;
begin
  result:= NetResObjFactory(FRes);
end;

///////////////////////////////////////////////////////////////////////////
//
// TNetResourceContainerObjU
//
///////////////////////////////////////////////////////////////////////////

constructor TNetResourceContainerObjU.Create(src:TNetResourceW);
begin
  inherited Create(src);
  FList:=TNetResourceObjListU.Create;
  FInitDone:=false;
end;

destructor  TNetResourceContainerObjU.Destroy;
begin
  if assigned(FList) then FList.free;
  inherited Destroy;
end;

function    TNetResourceContainerObjU.GetCount:integer;
begin
  if NOT FInitDone then UpdateChildren;
  result:=FList.count;
end;

function    TNetResourceContainerObjU.GetChildren(index:integer):TNetResourceObjU;
begin
  if NOT FInitDone then UpdateChildren;
  result:=FList.NRObjU[index]
end;

procedure   TNetResourceContainerObjU.Update;
begin
  UpdateChildren;
end;

procedure   TNetResourceContainerObjU.UpdateChildren;
begin
  FList.Clear;
  GetNetworkListU(@FRes,RESOURCE_GLOBALNET,RESOURCETYPE_ANY,0,FList,false,true);
  FInitDone:=true;
end;

function TNetResourceContainerObjU.Duplicate:TNetResourceObjU;
var
  i : integer;
begin
  result:=inherited Duplicate;
  // CountQƂƋIupdateĂ܂̂...
  for i := 0 to FList.Count - 1 do
    (result as TNetResourceContainerObjU).FList.addObject(children[i].RemoteName,Children[i].Duplicate);
end;

///////////////////////////////////////////////////////////////////////////
//
// TServerObjU
//
///////////////////////////////////////////////////////////////////////////

function TServerObjU.PlasticShareName(AName:string):string;
var
  i : integer;
begin
  if AName='' then begin
    result:=''; Exit;
  end;
  //
  i:=Pos(AnsiUpperCase(RemoteName),AnsiUpperCase(AName));
  if i=0 then begin
    // //srv
    if AName[1]='/' then
      AName:=RemoteName+AName
    else
      AName:=RemoteName+'/'+AName;
  end;
  result:=AName;
end;

function TServerObjU.FindShareIndex(AName:string):integer;
var
  i : integer;
begin
  if NOT InitDone then UpdateChildren;
  if FList.Find(PlasticShareName(AName),i) then
    result:=i
  else
    result:=-1;
end;

function TServerObjU.FindShare(AName:string):TNetResourceObjU;
var
  i : integer;
begin
  i:=FindShareIndex(AName);
  if i>=0 then
    result:=Children[i]
  else
    result:=nil;
end;

///////////////////////////////////////////////////////////////////////////
//
// TDomainObjU
//
///////////////////////////////////////////////////////////////////////////

function    TDomainObjU.GetServer(index:integer):TServerObjU;
begin
  result:=Children[index] as TServerObjU;
end;

function    TDomainObjU.PlasticSrvName(AName:string):string;
var
  w : string;
begin
  // l[
  if AName='' then begin
    result:=''; Exit;
  end;
  //
  w:=copy(AName,1,2);
  if w<>'\\' then AName:='\\'+AName;
  result:=AName;
end;

function    TDomainObjU.FindSrvIndex(AName:string):integer;
var
  i : integer;
begin
  if NOT InitDone then UpdateChildren;
  IF FList.Find(PlasticSrvName(AName),i) THEN
    result:=i
  ELSE
    result:=-1;
end;

function    TDomainObjU.FindServer(AName:string):TServerObjU;
var
  i : integer;
begin
  i:=FindSrvIndex(AName);
  if i>=0 then
    result:=Server[i]
  else
    result:=nil;
end;

function GetNetworkListU(pRootRes:PNetResourceW; Scope,ResType,Usage:DWORD; list:TStrings; recursive,needobj:boolean):integer;
const
  CBUFSIZE = 16*1024;
var
  hEnum : THANDLE;
  buf : array[0..CBUFSIZE] of widechar;
  count,bufsize : DWORD;
  nra : PNetResourceWArray;
  i : integer;
  rname : String;
  sts  : DWORD;
begin
  needobj:=needobj AND (list<>nil); // guard
  result:=WNetOpenEnumW(Scope,ResType,Usage,pRootRes,hEnum);
  IF result<>NO_ERROR THEN Exit;
  try
    FillChar(buf,sizeof(buf),0); sts:=NO_ERROR;
    WHILE result<>ERROR_NO_MORE_ITEMS DO BEGIN
      count:=$FFFFFFFF; bufsize:=CBUFSIZE;
      result:=WNetEnumResourceW(hEnum,count,@buf[0],bufsize);
      CASE result OF
        NO_ERROR:
          BEGIN
            nra:=PNetResourceWArray(@buf[0]);
            FOR i:=0 TO count-1 DO BEGIN
              rname:=string(nra^[i].lpRemoteName);
              IF needobj THEN
                list.AddObject(rname,NetResObjFactory(nra^[i]))
              ELSE
                list.Add(rname);
              // scopeRESOURCE_CONTEXT͍̎ċAȂ
              IF (scope<>RESOURCE_CONTEXT) AND recursive AND (0<>(nra^[i].dwUsage AND RESOURCEUSAGE_CONTAINER)) THEN
                sts:=GetNetworkListU(@(nra^[i]),Scope,ResType,Usage,list,recursive,needobj);
            END;
          END;
        ERROR_NO_MORE_ITEMS:
          ;
        ELSE BEGIN
          // WriteLog('err? : '+IntToStr(result));
          break;
        END;
      END;
      IF (sts<>NO_ERROR) THEN break;
    END;
  finally
    WNetCloseEnum(hEnum);
  end;
  IF sts<>NO_ERROR THEN
    result:=sts
  ELSE IF result=ERROR_NO_MORE_ITEMS THEN
    result:=NO_ERROR;
end;

end.
