unit ayanetutilu;

//////////////////////////////////////////////////////////////////////////
//
// lbg[N֘A̎֐^葱Ȃ
//
// rev. 1
// date 2009/05/26
// auth 
// memo ayafutiltꕔlbg[N֘A̎葱E֐𕪗
//      ŃXbhZ[twł͂ȂxB
//
// rev. 2
// date 2009/06/03-
// auth 
// memo XbhZ[tȎ葱E֐̍쐬
//
//////////////////////////////////////////////////////////////////////////

interface

uses
  windows,sysutils,classes,ayanetobjs;

// ȉ̊֐͕
//function GetDomainObj:TDomainObjU;
//function FindUNCObj(ATrg:String):TNetResourceObjU; // ATrg͐΃pXwłƉ

// XbhZ[tȊ֐葱
function MakeDomainObj:TDomainObjU;

function UpdateDomainObj:boolean;
function UpdateSrvObj(AServerName:string):boolean;
function GetServerNameList(ADupObj:boolean):TStringList;
function GetShareNameList(AServer:string; AResTypes:TNRResTypes; ADupObj:boolean):TStringList;

function FindAndDupUNCObj(ATrg:String):TNetResourceObjU; // ATrg͐΃pXwłƉ
function GetAndDupDomainObj:TDomainObjU;

implementation

uses
  ayafutilu;

var
  NetSyncObj : TMultiReadExclusiveWriteSynchronizer;

function MakeDomainObj:TDomainObjU;
const
  PROVIDERNAME = 'Microsoft Windows Network';
var
  Res : TNetResourceW;
  domainname : string;
begin
  domainname:=GetBelongDomainName;
  if domainname='' then
    result:=nil
  else begin
    with res do begin
      dwScope:=RESOURCE_GLOBALNET;
      dwType:=RESOURCETYPE_ANY;
      dwDisplayType:=RESOURCEDISPLAYTYPE_DOMAIN;
      dwUsage:=RESOURCEUSAGE_CONTAINER;
      lpLocalName:=nil;
      lpRemoteName:=@domainname[1];
      lpComment:=nil;
      lpProvider:=@PROVIDERNAME[1];
    end;
    result:=TDomainObjU.Create(res);
  end;
end;

// ʕ̃lbg[NǗ
var
  FMyDomain:TDomainObjU;


function GetDomainObj:TDomainObjU;
begin
  NetSyncObj.BeginWrite; // ...܂Ӗ͂Ȃ
  try
    if FMyDomain=nil then FMyDomain:=MakeDomainObj;
    result:=FMyDomain;
  finally
    NetSyncObj.EndWrite;
  end;
end;

function GetAndDupDomainObj:TDomainObjU;
begin
  NetSyncObj.BeginWrite; // ...܂Ӗ͂Ȃ
  try
    if FMyDomain=nil then FMyDomain:=MakeDomainObj;
    result:=FMyDomain.Duplicate as TDomainObjU;
  finally
    NetSyncObj.EndWrite;
  end;
end;

function FindUNCObj(ATrg:String):TNetResourceObjU;
var
  ASrvName,AShareName : string;
  ADomain : TDomainObjU;
  ASrv : TServerObjU;
  AShare : TNetResourceObjU;
begin
  NetSyncObj.BeginRead;
  try
    result:=nil;
    // Domain̑݃`FbN
    ADomain:=GetDomainObj;
    if ADomain=nil then Exit; // WORKGROUP or DOMAINɏĂȂ
    // Servercheck
    ASrvName:=ExtractDirLevelU(ATrg,-1);
    ASrv:=ADomain.FindServer(ASrvName);
    if ASrv=nil then Exit; // Server݂Ȃ
    if IsUNCServerU(ATrg) then begin
      result:=ASrv; Exit; // ΏۂServer̂ŁAԂ
    end;
    // Lcheck
    AShareName:=ExtractDirLevelU(ATrg,0);
    AShare := ASrv.FindShare(AShareName);
    if AShare=nil then Exit; // L݂Ȃ
    if IsUNCShareNameU(ATrg) then begin
      result:=AShare; Exit; // ΏۂL̂ŁAԂ
    end;
    // ȊOnilԋp
  finally
    NetSyncObj.EndRead;
  end;
end;

function FindAndDupUNCObj(ATrg:String):TNetResourceObjU; // ATrg͐΃pXwłƉ
var
  o : TNetResourceObjU;
begin
  NetSyncObj.BeginRead;
  try
    o:=FindUNCObj(ATrg);
    if o<>nil then
      result:=o.duplicate
    else
      result:=nil;
  finally
    NetSyncObj.EndRead;
  end;
end;

function UpdateDomainObj:boolean;
var
  domainname : string;
begin
  NetSyncObj.BeginWrite;
  try
    result:=false;
    domainname:=GetBelongDomainName;
    if domainname='' then begin
      // domainworkgroupɏĂȂꍇ
      if assigned(FMyDomain) then FreeAndNil(FMyDomain);
    end else begin
      if NOT Assigned(FMyDomain) then
        FMyDomain:=MakeDomainObj
      else if domainname<>FMyDomain.RemoteName then begin
        // hCςĂ̂ŁA蒼
        FreeAndNil(FMyDomain);
        FMyDomain:=MakeDomainObj;
      end;
      FMyDomain.Update;
      result:=true;
    end;
  finally
    NetSyncObj.EndWrite;
  end;
end;

function UpdateSrvObj(AServerName:string):boolean;
var
  ASrv : TServerObjU;
begin
  result:=false;
  if NOT IsUNCServerU(AServerName) then Exit;
  try
    NetSyncObj.BeginWrite;
    try
      ASrv:=FindUNCObj(AServerName) as TServerObjU;
      if ASrv<>nil then begin
        ASrv.Update;
        result:=true;
      end;
    finally
      NetSyncObj.EndWrite;
    end;
  except on EInvalidCast do
    ;
  end;
end;


function GetServerNameList(ADupObj:boolean):TStringList;
var
  domain : TDomainObjU;
  i : integer;
begin
  result:=TStringList.Create;
  NetSyncObj.BeginRead;
  try
    domain:=GetDomainObj;
    if domain<>nil then begin
      for I := 0 to domain.Count - 1 do
        if ADupObj then
          result.AddObject(domain.server[i].RemoteName,domain.Server[i].Duplicate)
        else
          result.Add(domain.server[i].RemoteName);
    end;
  finally
    NetSyncObj.EndRead;
  end;
end;

function GetShareNameList(AServer:string; AResTypes:TNRResTypes; ADupObj:boolean):TStringList;
var
  o : TNetResourceObjU;
  srv: TServerObjU;
  i : integer;
begin
  result:=TStringList.Create;
  NetSyncObj.BeginRead;
  try
    o:=FindUNCObj(AServer);
    if (o<>nil) and (o is TServerObjU) then begin
      srv:=TServerObjU(o);
      for I := 0 to srv.Count - 1 do
        if (srv.Children[i].ResTypes*AResTypes)<>[] then
          if ADupObj then
            result.AddObject(srv.Children[i].RemoteName,srv.Children[i].Duplicate)
          else
            result.Add(srv.Children[i].RemoteName);
    end;
  finally
    NetSyncObj.EndRead;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
//
// jbg̏
//
//////////////////////////////////////////////////////////////////////////////
procedure Init;
begin
  FMyDomain:=nil;
  NetSyncObj:=TMultiReadExclusiveWriteSynchronizer.Create;
end;

//////////////////////////////////////////////////////////////////////////////
//
// jbg̏I
//
//////////////////////////////////////////////////////////////////////////////
procedure Done;
begin
  if Assigned(FMyDomain) then FreeAndNil(FMyDomain);
  if Assigned(NetSyncObj) then FreeAndNil(NetSyncObj);
end;

initialization
  Init;

finalization
  Done;

end.
