unit reparseutils;

{*********************************************************************
 *
 * Symlink/Junktion/hardlink߂̎葱
 *
 * rev. 1
 * auth 
 * date 2009/07/01
 * memo o
 *
 * rev. 2
 * auth 
 * date 2009/07/04
 * memo Junction/SymbolicLink̉T|[g
 *
 *********************************************************************}

interface

uses
  sysutils,windows;

const
  MAXIMUM_REPARSE_DATA_BUFFER_SIZE = (16*1024); // from winnt.h
  REPARSE_GUID_DATA_BUFFER_HEADER_SIZE = 24;    // }NŌvZĂ̂....

  IO_REPARSE_TAG_MOUNT_POINT       = $A0000003;
  IO_REPARSE_TAG_SYMLINK           = $A000000C;

  FILE_ATTRIBUTE_VIRTUAL           = $00010000;

  FSCTL_SET_REPARSE_POINT          = $000900A4;
  FSCTL_GET_REPARSE_POINT          = $000900A8;
  FSCTL_DELETE_REPARSE_POINT       = $000900AC;

  FILE_FLAG_OPEN_REPARSE_POINT     = $00200000;

  SYMLINK_FLAG_DIRECTORY           = 1;

  FILE_READ_EA                     = $0008;

type
  TSymbolicLinkReparseBuffer = packed record
    SubstituteNameOffset,
    SubstituteNameLength,
    PrintNameOffset,
    PrintNameLength      : WORD;
    Flags                : DWORD;
    PathBuffer           : array[0..0] of WideChar;
  end;

  TMountPointReparseBuffer = packed record
    SubstituteNameOffset,
    SubstituteNameLength,
    PrintNameOffset,
    PrintNameLength      : WORD;
    PathBuffer           : array[0..0] of WideChar;
  end;

  TReparseGUIDDataBuffer = packed record
    ReparseGuid : TGUID;
    DataBuffer : array[0..0] of Byte;
  end;

  TReparseDataBuffer = packed record
    ParseTag          : DWORD;
    ReparseDataLength : WORD;
    Reserved          : WORD;
    case integer of
      0 : (ASymLink              :TSymbolicLinkReparseBuffer);
      1 : (AJunction             :TMountPointReparseBuffer);
      2 : (AReparseData          :TReparseGUIDDataBuffer);
      3 : (AGenericReparseBuffer :array[0..MAXIMUM_REPARSE_DATA_BUFFER_SIZE-1] of WCHAR);
  end;
  PReparseDataBuffer = ^TReparseDataBuffer;

  TReparseType = (rpstNONE,rpstJNC,rpstSYM); // Jnc/SymȊO, Junction, SYmbolicLink

// JunctionSymbolicLink̃N̖O擾
function GetRealPathFromJncSym(ATrg:string):string;

// hardlink - w2kȍ~ACreateHardlink֐ok

// CreateJunction
//   from ln.c - http://homepage1.nifty.com/emk/symlink.html
//   ̊֐̂̓t@Cɑ΂Ă삵܂Aۂɂ̓fBNgɂ̂
//   gpقǂB
function CreateJunction(lpLinkName,lpTargetName:PWideChar; lpsa:PSecurityAttributes ):BOOL;

// CreateSymbolicLink - vistaȍ~AASymbolicLink쐬̌ƍ쐬s
function CreateSymbolicLink(lpSymlinkFileName,lpTargetFileName : PWideChar; dwFlags:DWORD):BOOL; stdcall;

// junctionsymboliclink̉
function DeleteJunction(lpTargetName:PWideChar):BOOL;

// Junction or SymbolicLink or ̑̔
function IsJncOrSym(ATrg:string):TReparseType;

// JunctionSymbolicLinkɖ߂ - ATrg̓tpXœnƁI
function ExpandReparseName(ATrg:string):string;

implementation

uses
  ayafutilu;

function GetRealPathFromJncSym(ATrg:string):string;
var
  hFile : THandle;
  work : TReparseDataBuffer;
  sz,err : DWORD;
  pPath : PWideChar;
  i : integer;
begin
  result:=''; err:=NO_ERROR;
  hFile:=CreateFile(PWideChar(ATrg),
                    FILE_READ_EA, // FILE_READ_EA~\
                    FILE_SHARE_READ OR FILE_SHARE_WRITE OR FILE_SHARE_DELETE,
                    nil,
                    OPEN_EXISTING,
                    FILE_FLAG_BACKUP_SEMANTICS OR FILE_FLAG_OPEN_REPARSE_POINT,
                    0);
  if hFile=INVALID_HANDLE_VALUE then exit;
  FillChar(work,sizeof(work),0);
  try
    if DeviceIoControl(hFile,
                       FSCTL_GET_REPARSE_POINT,
                       nil,
                       0,
                       PByte(@work),
                       sizeof(work),
                       sz,
                       nil) then begin
      case work.ParseTag of
        IO_REPARSE_TAG_MOUNT_POINT :
          begin
            // junktion
            pPath:=@(work.AJunction.PathBuffer[0]);
            Inc(pPath,work.AJunction.SubstituteNameOffset div sizeof(WideChar));
            for i := 0 to Work.AJunction.SubstituteNameLength div sizeof(WideChar) - 1 do
              result:=result+(pPath+i)^;
          end;
        IO_REPARSE_TAG_SYMLINK     :
          begin
            // symlink
            pPath:=@(work.ASymLink.PathBuffer[0]);
            Inc(pPath,work.ASymLink.SubstituteNameOffset div sizeof(WideChar));
            for i := 0 to Work.ASymLink.SubstituteNameLength div sizeof(WideChar) - 1 do
              result:=result+(pPath+i)^;
          end;
      end;
    end else
      err:=GetLastError;
  finally
    CloseHandle(hFile);
    if err<>NO_ERROR then SetLastError(err);
  end;
end;

function CreateJunction(lpLinkName,lpTargetName:PWideChar; lpsa:PSecurityAttributes ):BOOL;
var
  isDir : boolean;
  attr,sz  : DWORD;
  fullpath : string;
  hFile : THandle;
  data  : TReparseDataBuffer;
begin
  result:=false;

  attr:=GetFileAttributes(lpTargetName);
  if (attr=INVALID_FILE_ATTRIBUTES) then exit;
  isDir:=(attr AND FILE_ATTRIBUTE_DIRECTORY)<>0;

  // tpXɕϊăRs[
  FillChar(data,sizeof(data),0);
  fullpath:='\??\'+ExpandFilename(string(lpTargetName));
  StrPCopy(@(data.AJunction.PathBuffer[0]),PWideChar(fullpath));

  // Nt@C쐬
  if isDir then begin
    if NOT CreateDirectory(lpLinkName,lpsa) then Exit;
    hFile:=CreateFile(lpLinkName,
                      GENERIC_WRITE,
                      FILE_SHARE_READ OR FILE_SHARE_WRITE,
                      nil,
                      OPEN_EXISTING,
                      FILE_FLAG_BACKUP_SEMANTICS, 0);
  end else begin
    hFile:=CreateFile(lpLinkName,
                      GENERIC_WRITE,
                      FILE_SHARE_READ OR FILE_SHARE_WRITE,
                      lpsa,
                      CREATE_NEW, 0, 0);
  end;
  if hFile=INVALID_HANDLE_VALUE then exit;

  // p[Xf[^
  with data do begin
    ParseTag:=IO_REPARSE_TAG_MOUNT_POINT;
    Reserved:=0;
    AJunction.SubstituteNameOffset:=0;
    AJunction.SubstituteNameLength:=Length(fullpath)*sizeof(WideChar);
    AJunction.PrintNameOffset:=AJunction.SubstituteNameLength+2;
    AJunction.PrintNameLength:=0;
    ReparseDataLength:=8+
                       AJunction.PrintNameOffset+
                       AJunction.PrintNameLength+2;
  end;
  sz:=8+data.ReparseDataLength;

  // p[Xf[^
  if NOT DeviceIoControl(hFile, FSCTL_SET_REPARSE_POINT, @data, sz, nil, 0, sz, nil) then begin
    CloseHandle(hFile);
    if isDir then
      RemoveDirectory(lpLinkName)
    else
      DeleteFile(lpLinkName);
  end else begin
    CloseHandle(hFile);
    result:=true;
  end;
end;

// junctionsymboliclink̉
{$WARN SYMBOL_PLATFORM OFF}
function DeleteJunction(lpTargetName:PWideChar):BOOL;
var
  sr  : TSearchRec;
  hFile : THandle;
  work : TReparseDataBuffer;
  sz,err : DWORD;
  isDir : boolean;
begin
  result:=false;

  // 擾
  if 0<>FindFirst(lpTargetName,faAnyFile,sr) then Exit;
  SysUtils.FindClose(sr);
  // reparsepointǂ𔻒
  if 0=(sr.FindData.dwFileAttributes and FILE_ATTRIBUTE_REPARSE_POINT) then begin
    SetLastError(ERROR_BAD_PATHNAME); // reparsepointł͂ȂI
    exit;
  end;
  // junction or symboliclink?
  if (sr.FindData.dwReserved0<>IO_REPARSE_TAG_MOUNT_POINT) and
     (sr.FindData.dwReserved0<>IO_REPARSE_TAG_SYMLINK) then begin
    SetLastError(ERROR_BAD_PATHNAME); // junctionłsymboliclinkłȂ
    exit;
  end;
  //
  isDir:=0<>(sr.FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY);

  // 폜Jn
  FillChar(work,sizeof(work),0);
  work.Reserved:=0;
  work.ReparseDataLength:=0;
  work.ParseTag:=sr.FindData.dwReserved0;

  if isDir then
    hFile:=CreateFile(lpTargetName,
                      GENERIC_WRITE,
                      FILE_SHARE_READ OR FILE_SHARE_WRITE,
                      nil,
                      OPEN_EXISTING,
                      FILE_FLAG_OPEN_REPARSE_POINT OR FILE_FLAG_BACKUP_SEMANTICS, 0)
  else
    hFile:=CreateFile(lpTargetName,
                      GENERIC_WRITE OR GENERIC_READ OR FILE_READ_EA,
                      FILE_SHARE_READ OR FILE_SHARE_WRITE,
                      nil,
                      OPEN_EXISTING, 0, 0);
  if DeviceIoControl(hFile,
                     FSCTL_DELETE_REPARSE_POINT,
                     @work,
                     REPARSE_GUID_DATA_BUFFER_HEADER_SIZE,
                     nil,
                     0,
                     sz,
                     nil) then begin
    CloseHandle(hFile);
    if isDir then
      result:=RemoveDirectory(lpTargetName)
    else
      result:=DeleteFile(lpTargetName);
  end else begin
    err:=GetLastError;
    CloseHandle(hFile);
    SetLastError(err);
  end;
end;

function IsJncOrSym(ATrg:string):TReparseType;
var
  sr : TSearchRec;
begin
  result:=rpstNONE;
  if 0<>FindFirst(ATrg,faAnyFile,sr) then exit;
  Sysutils.FindClose(sr);
  with sr.FindData do
    if (dwFileAttributes and FILE_ATTRIBUTE_REPARSE_POINT)<>0 then
      case dwReserved0 of
        IO_REPARSE_TAG_MOUNT_POINT:
          result:=rpstJnc;
        IO_REPARSE_TAG_SYMLINK:
          result:=rpstSym;
      end;
end;

// ̃`FbN > efBNg̃`FbN > Xɐe...
// ATrgexpandς݂ł邱ƂO
function ExpandReparseName(ATrg:string):string;
const
  LocalHeader = '\??\';
  UNCHeader   = '\??\UNC\';
var
  work,path,fname : string;
begin
  if ATrg='' then begin
    result:=''; exit;
  end;
  { {͂肽AL̃[JpXϊłȂ̂...
  if IsRootDriveU(ATrg) OR IsUNCServerU(ATrg) then begin
    // drive,server炻̂܂܏I
    result:=ATrg; Exit;
  end else if IsUNCShareNameU(ATrg) then begin
    // sharenamȅꍇȀ鋤Lꍇ̓[Jɕϊčă`FbN
    path:=ExtractDirLevelU(ATrg,-1);
    if CompareText(path,'\\'+GetMyMachineName)=0 then
      // ̏UNCȂ̂localɕϊĂAēxWJ
      result:=ExpandReparseName(ConvUNCtoLocal(ATrg))
    else
      // ̃}VUNCȂ̂ł̂܂ܕԋp
      result:=ATrg;
  }
  if IsRootDriveU(ATrg) OR IsUNCServerU(ATrg) OR IsUNCShareNameU(ATrg) then begin
    // drive,server,sharename炻̂܂܏I
    result:=ATrg; Exit;
  end else begin
    // ȂꍇA \ 폜Ă
    if ATrg[Length(ATrg)]='\' then ATrg:=Copy(ATrg,1,Length(ATrg)-1);
  end;
  //
  if IsJncOrSym(ATrg)<>rpstNONE then begin
    // gJunction or SymbolicLinkȂ΃IWipX̎擾
    work:=GetRealPathFromJncSym(ATrg);
    if work='' then
      result:=Atrg // 擾s̂ŁAǂ悤Ȃ
    else begin
      // ^̃pXč\z
      if UNCHeader=Copy(work,1,Length(UNCHeader)) then
        // UNCpXw
        work:='\\'+copy(work,Length(UNCHeader)+1,Length(work)-Length(UNCHeader))
      else if LocalHeader=Copy(work,1,Length(LocalHeader)) then
        // ΃pXw
        work:=Copy(work,Length(LocalHeader)+1,Length(work)-Length(LocalHeader))
      else begin
        // ΃pXH
        if work[1]='\' then begin
          // N̎w \hoge\hoga ƂłB
          // ̏ꍇArootdrive:hoge\hugaɂȂB
          work:=ExpandUNCFilename(ExtractFileDrive(ATrg)+'\'+work);
        end else
          // t@C̃pXɓWJ
          work:=ExpandUNCFilename(ExtractFilePath(ATrg)+work);
      end;
      // ߂ă`FbN
      result:=ExpandReparseName(work);
    end;
  end else begin
    // gok̂ŁAe`FbN
    path:=ExtractFilePath(ATrg); fname:=ExtractFilename(ATrg);
    result:=ExpandReparseName(Path);
    if result[Length(result)]<>'\' then
      result:=result+'\'+fname
    else
      result:=result+fname;
  end;
end;

var
  hKernel32 : THandle;
  p : TFarProc;
  _CreateSymbolicLink: function(lpSymlinkFileName,lpTargetFileName : PWideChar; dwFlags:DWORD):BOOL; stdcall;

function CreateSymbolicLink(lpSymlinkFileName,lpTargetFileName : PWideChar; dwFlags:DWORD):BOOL; stdcall;
begin
  if @_CreateSymbolicLink=nil then begin
    result:=false;
    SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
  end else
    result:=_CreateSymbolicLink(lpSymlinkFileName,lpTargetFileName,dwFlags);
end;

procedure Init;
begin
  _CreateSymbolicLink:=nil;
  hKernel32:=LoadLibrary('kernel32.dll');
  if hKernel32<>0 then begin
    p:=GetProcAddress(HKernel32,'CreateSymbolicLinkW');
    if p<>nil then @_CreateSymbolicLink:=p;
  end;
end;

procedure Done;
begin
  if hKernel32<>0 then begin
    _CreateSymbolicLink:=nil;
    FreeLibrary(hKernel32);
    hKernel32:=0;
  end;
end;

initialization
  Init;

finalization
  Done;

end.
