unit saveprogf;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

const
  WM_SHOWFIRST = WM_APP+$500;

type
  TSaveProgForm = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    ProgBar: TProgressBar;
    CancelBtn: TButton;
    procedure FormShow(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private 錾 }
    FSrc,FDst : string;
    FOrgSize : int64;
    done,
    stop,
    ShowFirst : boolean;
    procedure WmShowFirst(var AMSg:TMSg); message WM_SHOWFIRST;
  public
    { Public 錾 }
    procedure DoSave(AnADSName:string; ASize:int64; ASaveName:string);
  end;

  procedure DoSave(AOwner:TComponent; AnADSName:string; ASize:int64; ASaveName:string);

implementation

{$R *.dfm}

procedure DoSave(AOwner:TComponent; AnADSName:string; ASize:int64; ASaveName:string);
var
  fm : TSaveProgForm;
begin
  fm:=TSaveProgForm.Create(AOwner);
  try
    fm.DoSave(AnADSName,ASize,ASaveName);
    fm.ShowModal;
  finally
    fm.free;
  end;
end;

procedure TSaveProgForm.DoSave(AnADSName:string; ASize:int64; ASaveName:string);
begin
  FSrc:=AnADSName; FOrgSize:=ASize; FDst:=ASaveName;
  ShowFirst:=true; stop:=false; done:=false;
end;

procedure TSaveProgForm.FormShow(Sender: TObject);
begin
  if ShowFirst then begin
    ShowFirst:=false;
    PostMessage(handle,WM_SHOWFIRST,0,0);
  end;
end;

procedure TSaveProgForm.CancelBtnClick(Sender: TObject);
begin
  if done then
    ModalResult:=mrOK
  else
    stop:=true;
end;

procedure TSaveProgForm.WmShowFirst(var AMSg:TMSg);
const
  bufsize = 4096;
var
  s,d : TFileStream;
  buf : array[0..bufsize-1] of byte;
  i,rdsize : integer;
  remain : int64;
begin
  s:=TFileStream.Create(FSrc,fmOpenRead);
  try
    d:=TFileStream.Create(FDst,fmCreate);
    try
      remain:=FOrgSize;
      while (remain>0) and (not stop) do begin
        //
        Application.ProcessMessages;
        // ǂݍ
        if remain>=bufsize then rdsize:=bufsize else rdsize:=remain;
        remain:=remain-rdsize;
        s.Read(buf[0],rdsize);
        Application.ProcessMessages;
        // o
        d.Write(buf[0],rdsize);
        Application.ProcessMessages;
        // progressbarf
        i:=(FOrgSize-remain)*100 div FOrgSize;
        if (i=0) and ((FOrgSize-remain)>0) then i:=1;
        ProgBar.Position:=i;
        ProgBar.Repaint;
      end;
    finally
      d.Free;
    end;
  finally
    s.free;
  end;
  //
  if stop then
    ModalResult:=mrCancel
  else begin
    done:=true;
    CancelBtn.Caption:='&Ok';
  end;
end;


end.
